<?php
/**
 *
 * @version mod_flexitree_menu
 * @package Joomla
 * @copyright Copyright (C) 2009 NetAssoPro - maxime.danjou@netassopro.com
 * @license GNU/GPL, see LICENSE.php
 *
 * File last changed 26.10.2009
 */
// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE . DS . 'components' . DS . 'com_flexicontent' . DS . 'helpers' . DS . 'route.php');

class FlexiTreeMenuHelper {
    function getCategoryList(&$params)
    {
        $catexc = trim($params->get('exlude_category', ''));
        $artexc = trim($params->get('exlude_article', ''));
        $list = FlexiTreeMenuHelper::getCategoriesTree($params->get("base_category", 0), $params->get("show_article", 1), $params->get("show_article_first", 1), $catexc, $artexc);
        return $list;
    }
    function getCategoriesTree($parentid = 0, $show_article = true, $first = true , $catexc, $artexc, $list = array())
    {
        $db = &JFactory::getDBO();
        $where[] = 'parent_id = ' . $parentid;
        $where[] = 'published = 1';
        $where[] = 'section = ' . FLEXI_SECTION;
        if ($catexc != '') {
            $catexcs = explode(',', $catexc);
            $where[] = '( id!=' . implode(' AND id!=', $catexcs) . ')';
        }
        $where = (count($where) ? ' WHERE ' . implode(' AND ', $where) : '');

        $query = 'SELECT id,parent_id,title,image,access'
         . ' FROM #__categories'
         . $where
         . ' ORDER BY parent_id, ordering' ;
        $db->setQuery($query);

        $rows = $db->loadObjectList();

        $index = 0;
        foreach ($rows as $child) {
            $list[$index] = $child;
            $list[$index]->link = FlexicontentHelperRoute::getCategoryRoute($child->id);
            if ($show_article) {
                $list[$index]->article = FlexiTreeMenuHelper::getArticleList($child->id, $artexc);
            }
            $list[$index]->children = FlexiTreeMenuHelper::getCategoriesTree($child->id, $show_article, false , $catexc, $artexc);
            $index++;
        }
        if ($show_article and $first) {
            $list[$index]->article = FlexiTreeMenuHelper::getArticleList($parentid, $artexc);
        }
        return $list;
    }
    function getArticleList($idcat, $artexc)
    {
        $db = &JFactory::getDBO();
        if ($artexc != '') {
            $artexcs = explode(',', $artexc);
            $where[] = '(c.id!=' . implode(' AND c.id!=', $artexcs) . ')';
        }
        $where[] = 'c.state = 1';
        $where[] = 'r.catid = ' . $idcat;
        $where = (count($where) ? ' WHERE ' . implode(' AND ', $where) : '');
        $query = 'SELECT distinct c.id, c.title'
         . ' FROM #__content AS c left OUTER JOIN  #__flexicontent_cats_item_relations r on c.id=r.itemid'
         . $where
         . ' ORDER BY c.title';
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        $list = array();
        $index = 0;
        foreach ($rows as $child) {
            $list[$index]->id = $child->id;
            $list[$index]->title = $child->title;
            $list[$index]->link = FlexicontentHelperRoute::getItemRoute($child->id, $idcat);
            $index++;
        }
        return $list;
    }
}